/*  Misfit Model 3D
 * 
 *  Copyright (c) 2004-2005 Kevin Worcester
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
 *  USA.
 *
 *  See the COPYING file for full license text.
 */

#if 0 

#ifndef __MENUMGR_H
#define __MENUMGR_H

#include <list>
#include <qpopupmenu.h>

class QWidget;

using std::list;

class MenuManager
{
   public:
      typedef enum MenuType_t
      {
         MenuMain,
         MenuModel
      } MenuType;

      class Menu : public QPopupMenu
      {
         public:
            virtual const char * getName() = 0;
      };

      class MenuMaker
      {
         public:
            virtual Menu * makeMenu( QWidget * parent ) = 0;
            virtual MenuType getMenuType() = 0;
      };

      static MenuManager * getInstance();
      static void release();

      void registerMenuMaker( MenuMaker * maker );

      list<Menu *> getMainMenus( QWidget * parent );
      list<Menu *> getModelMenus( QWidget * parent );

   protected:
      MenuManager();
      virtual ~MenuManager();

      list<MenuMaker *> m_list;

      static MenuManager * s_instance;
};

#endif // __MENUMGR_H
#endif // 0
